/**
 * Painter Applet
 * ==============
 * Version 1.0	Date:26/01/2000
 * Auteur : Vouriot Thierry
 * Mail : thierry.vouriot@free.fr
 *
 * Taille minimum de l'applet 400*300
 * Bugs connus : - fonctionnement moins efficace sous IE (bugs mineurs)
 * - pinceau en forme d'angle droit
 */

import java.applet.Applet;
import java.awt.*;
import java.awt.event.*;

/** Dessine un rectangle qui represente la zone de dessin */
class Feuille extends Canvas {
    Dimension mesDimensions = new Dimension();
    
    public Feuille(int largeur, int hauteur, Color c) //Constructeur
    {
        mesDimensions.width = largeur;
        mesDimensions.height = hauteur;
        setForeground(c);
    }
    
    public void paint(Graphics g) //Dessine la feuille
    {
        g.fillRect(0,0,mesDimensions.width,mesDimensions.height);
    }
    public void setColor(Color c) //Change la couleur de la feuille
    {
        setForeground(c);
        repaint();
    }
    
    public Dimension getPreferredSize() {
        return mesDimensions;
    }
    public Dimension getMinimumSize() {
        return mesDimensions;
    }
}

/** Class principale */
public class Painter extends Applet implements ActionListener,ItemListener {
    
    Panel commandes = new Panel();
    Panel titre = new Panel();
    Panel dessin = new Panel();
    Panel commandesTitres	= new Panel();
    Panel commandesInterface	= new Panel();
    
    int red,green,blue;
    int tailleCrayon = 1;
    Color couleurFeuille = Color.black;
    Color couleurCrayon = Color.white;
    
    Button boutonAbout = new Button(" ? ");
    Button boutonnew = new Button("New");
    Button boutonPlus = new Button("+");
    Button boutonMoins = new Button("-");
    
    Label lblTaille= new Label("Taille : "+tailleCrayon);
    Label lblPinceau= new Label("Pinceau : ",0);
    Label lblFeuille= new Label("Feuille :                     ",0);
    Choice comboCrayon = new Choice();
    Choice comboFond = new Choice();
    
    traceurSouris crayon = new traceurSouris(couleurCrayon,tailleCrayon);
    
    Feuille r;
    Frame fAbout;
    boolean about = false;
    
    /** Initialisation des variables et mise en place de l'interface */
    public void init() {
        fAbout = new FenetreAbout("About Painter Applet");
        fAbout.resize(230,190);
        fAbout.setLocation(100,100);
        fAbout.setResizable(false);
        
        comboCrayon.addItem("Blanc");
        comboCrayon.addItem("Noir");
        comboCrayon.addItem("Rouge");
        comboCrayon.addItem("Vert");
        comboCrayon.addItem("Bleu");
        comboCrayon.addItem("Jaune");
        comboCrayon.addItem("Orange");
        comboCrayon.addItem("Cyan");
        comboCrayon.addItem("Magenta");
        comboCrayon.addItemListener(this);
        
        comboFond.addItem("Noir");
        comboFond.addItem("Blanc");
        comboFond.addItem("Rouge");
        comboFond.addItem("Vert");
        comboFond.addItem("Bleu");
        comboFond.addItem("Jaune");
        comboFond.addItem("Orange");
        comboFond.addItem("Cyan");
        comboFond.addItem("Magenta");
        
        //Recuperation et traitement des parametres de la page HTML
        int hauteur = Integer.parseInt(getParameter("height"));
        int largeur = Integer.parseInt(getParameter("width"));
        r = new Feuille(largeur-20,hauteur-80,couleurFeuille);
        String bgcolor = getParameter("bgcolor");
        red = Integer.parseInt(bgcolor.substring(0,3));
        green = Integer.parseInt(bgcolor.substring(4,7));
        blue = Integer.parseInt(bgcolor.substring(8));
        setBackground(new Color(red,green,blue));
        
        setLayout(new BorderLayout());
        commandes.setLayout(new BorderLayout());
        add("South",commandes);
        add("North",titre);
        add("Center",dessin);
        commandes.add("South",commandesInterface);
        commandes.add("North",commandesTitres);
        
        dessin.add(r);
        titre.add(new Label("PAINTER APPLET"));
        
        commandesTitres.add(lblFeuille);
        commandesTitres.add(new Label("         "));
        commandesTitres.add(lblPinceau);
        
        commandesInterface.add(boutonnew);
        commandesInterface.add(comboFond);
        commandesInterface.add(new Label("     "));
        commandesInterface.add(comboCrayon);
        commandesInterface.add(boutonPlus);
        commandesInterface.add(boutonMoins);
        commandesInterface.add(lblTaille);
        commandesInterface.add(boutonAbout);
        
        boutonnew.addActionListener(this);
        boutonPlus.addActionListener(this);
        boutonMoins.addActionListener(this);
        boutonAbout.addActionListener(this);
        
        r.addMouseMotionListener(crayon);
        r.addMouseListener(crayon);
    }
    
    /** Methode reagissant en fonction du bouton click */
    public void actionPerformed(java.awt.event.ActionEvent evt) {
        if (evt.getSource() == boutonAbout) {
            if (about == false){
                fAbout.show();
                about = true;}
            else{
                fAbout.hide();
                about = false;}
            
        }
        
        if (evt.getSource() == boutonnew) {
            if (comboFond.getSelectedItem().equals("Noir"))
                couleurFeuille=Color.black;
            if (comboFond.getSelectedItem().equals("Blanc"))
                couleurFeuille=Color.white;
            if (comboFond.getSelectedItem().equals("Rouge"))
                couleurFeuille=Color.red;
            if (comboFond.getSelectedItem().equals("Vert"))
                couleurFeuille=Color.green;
            if (comboFond.getSelectedItem().equals("Bleu"))
                couleurFeuille=Color.blue;
            if (comboFond.getSelectedItem().equals("Jaune"))
                couleurFeuille=Color.yellow;
            if (comboFond.getSelectedItem().equals("Orange"))
                couleurFeuille=Color.orange;
            if (comboFond.getSelectedItem().equals("Cyan"))
                couleurFeuille=Color.cyan;
            if (comboFond.getSelectedItem().equals("Magenta"))
                couleurFeuille=Color.magenta;
            
            r.setColor(couleurFeuille);
        }
        if (evt.getSource() == boutonPlus && tailleCrayon != 10) {
            tailleCrayon = tailleCrayon + 1;
            crayon.setSize(tailleCrayon);
        }
        if (evt.getSource() == boutonMoins && tailleCrayon != 1) {
            tailleCrayon = tailleCrayon - 1;
            crayon.setSize(tailleCrayon);
        }
        lblTaille.setText("Taille : "+tailleCrayon);
        
        
    }
    /** Methode reagissant si l'utilisateur change d'item dans la combo Liste
                definissant la couleur du pinceau */
    
    public void itemStateChanged(ItemEvent e) {
        if (e.getItem().toString().equals("Blanc"))
            crayon.setColor(Color.white);
        if (e.getItem().toString().equals("Noir"))
            crayon.setColor(Color.black);
        if (e.getItem().toString().equals("Rouge"))
            crayon.setColor(Color.red);
        if (e.getItem().toString().equals("Vert"))
            crayon.setColor(Color.green);
        if (e.getItem().toString().equals("Bleu"))
            crayon.setColor(Color.blue);
        if (e.getItem().toString().equals("Jaune"))
            crayon.setColor(Color.yellow);
        if (e.getItem().toString().equals("Orange"))
            crayon.setColor(Color.orange);
        if (e.getItem().toString().equals("Cyan"))
            crayon.setColor(Color.cyan);
        if (e.getItem().toString().equals("Magenta"))
            crayon.setColor(Color.magenta);
    }
}

/** Permet de gerer les evenements de la souris */
class traceurSouris implements MouseMotionListener,MouseListener {
    private Color Couleur;
    private int taille;
    private int startX = 0;
    private int startY = 0;
    
    traceurSouris(Color c,int t)  //Constructeur
    {
        taille = t;
        Couleur = c;
    }
    
    public void setColor(Color c) {
        Couleur = c;
    }
    
    public void setSize(int t) {
        taille = t;
    }
    
    public void mouseDragged(MouseEvent e) {
        Graphics g = e.getComponent().getGraphics();
        g.setColor(Couleur);
        int k = 1;
        
        while (k<=taille) {
            g.drawLine(startX+1,startY+k,e.getX()+1,e.getY()+k);
            g.drawLine(startX+k,startY,e.getX()+k,e.getY());
            g.drawLine(startX,startY+k,e.getX()+k,e.getY());
            g.drawLine(startX+k,startY,e.getX(),e.getY()+k);
            k++;
        }
        startX = e.getX();
        startY = e.getY();
    }
    
    public void mouseMoved(MouseEvent e) {
        startX=e.getX();
        startY=e.getY();
    }
    public void mousePressed(MouseEvent e) {
        Graphics g = e.getComponent().getGraphics();
        g.setColor(Couleur);
        int k=0;
        while (k<=taille) {
            g.drawLine(startX,startY+k,e.getX(),e.getY()+k);
            g.drawLine(startX+k,startY,e.getX()+k,e.getY());
            g.drawLine(startX,startY+k,e.getX()+k,e.getY());
            g.drawLine(startX+k,startY,e.getX(),e.getY()+k);
            k++;
        }
        
    }
    
    public void mouseClicked(MouseEvent e){ }
    
    public void mouseReleased(MouseEvent e) {
        Graphics g = e.getComponent().getGraphics();
        g.setColor(Couleur);
        int k=0;
        while (k<=taille) {
            g.drawLine(startX,startY+k,e.getX(),e.getY()+k);
            g.drawLine(startX+k,startY,e.getX()+k,e.getY());
            g.drawLine(startX,startY+k,e.getX()+k,e.getY());
            g.drawLine(startX+k,startY,e.getX(),e.getY()+k);
            k++;
        }
    }
    
    public void mouseEntered(MouseEvent e){ }
    
    public void mouseExited(MouseEvent e){ }
    
}

/** Class definissant la fenetre About */
class FenetreAbout extends Frame {
    public FenetreAbout(String titre){ super(titre); }
    
    public void paint(Graphics g) {
        Font f1 = new Font("TimesRoman", Font.PLAIN, 20);
        g.setFont(f1);
        g.drawString("Painter Applet", 50, 40);
        
        Font f2 = new Font("TimesRoman", Font.PLAIN, 14);
        g.setFont(f2);
        g.drawString("Version 1.0  Date: 26/01/2000", 28, 60);
        g.drawString("Auteur : Thierry Vouriot", 54, 80);
        
        Font f3 = new Font("TimesRoman", Font.ITALIC, 14);
        g.setFont(f3);
        g.drawString("E-mail: thierry.vouriot@free.fr", 26, 100);
        
        Font f4 = new Font("TimesRoman", Font.PLAIN, 14);
        g.setFont(f4);
        g.drawString("http://thierry.vouriot.free.fr", 28, 120);
        
        Font f5 = new Font("TimesRoman", Font.PLAIN, 11);
        g.setFont(f5);
        g.drawString("Pressez |?| pour quitter cette fentre", 37, 146);
    }
}
